import delphi_module as dm

btEsc = 0
btOK = 1


# form dictionary convert to string
def fd2str(d):
    s = ''
    for key, value in d.items():
        if isinstance(value,dict):
            for key2, value2 in value.items():
                if isinstance(value2,bool):
                    if value2:
                        v = 'True'
                    else:
                        v = 'False'
                elif isinstance(value2,int):
                    v = str(value2)
                else:
                    v = value2
                    if key2 == 'Action': v = v.replace('\n','\3')
                s = s+key+'.'+key2+' = '+v+'\r\n'
    return s


def fans(s):
    a = {}
    if s == '' or s == '_NO_ANSWER_':
        a['Answer'] = btEsc
    else:
        a['Answer'] = btOK
        s = s.replace('\n','')
        b = s.split('\r')
        for i in range(len(b)):
            p = b[i].split('=')
            if len(p) > 1:
                r = p[0].split('.')
                if len(r) > 1:
                    if p[0][0:4] == 'Edit' or p[0][0:4] == 'Memo':
                        a[r[0]] = {'Text' : p[1]}
                    if p[0][0:4] == 'Spin':
                        a[r[0]] = {'Value' : int(p[1])}
                    if p[0][0:5] == 'Combo' or p[0][0:4] == 'List':
                        q = p[1].split('\3')
                        a[r[0]] = {'Index' : int(q[0]), 'Item' : q[1], 'SetText' : q[2]}
                    if p[0][0:5] == 'Check':
                        a[r[0]] = {'Done' : (p[1] == 'True')}
                    if p[0][0:5] == 'Notes':
                        q = p[1].split('\3')
                        a[r[0]] = {'Agree' : q[0], 'AgreeItems' : q[1]}
    return a


def Folders(caption, *args):
    if len(args) == 0:
        initdir = ''
        cancreatenewdir = False
    elif len(args) == 1:
        initdir = args[0]
        cancreatenewdir = False
    else:
        initdir = args[0]       
        cancreatenewdir = args[1]
    return dm.Folders(caption, initdir, cancreatenewdir)


def Menu(caption, itemlist, *args):
    if len(args) == 0:
        istart = 1
        width = 300
        fontsize = 8
    elif len(args) == 1:
        istart = args[0]
        width = 300
        fontsize = 8
    elif len(args) == 2:
        istart = args[0]
        width = args[1]
        fontsize = 8
    else:
        istart = args[0]
        width = args[1]
        fontsize = args[2]
    s = '\3'.join(itemlist)
    return dm.Menu(caption, s, istart, width, fontsize)


def Input(caption, prompts, *args):
    if len(args) == 0:
        width = 300
        ratio = 0.5
        fontsize = 8
    elif len(args) == 1:
        width = args[0]
        ratio = 0.5
        fontsize = 8
    elif len(args) == 2:
        width = args[0]
        ratio = args[1]
        fontsize = 8
    else:
        width = args[0]
        ratio = args[1]
        fontsize = args[2]
    s = '\3'.join(prompts)
    return dm.Input(caption, s, width, ratio, fontsize).split('\3')


def Form(t, *args):
    if len(args) == 0:
        upd = ''
    else:
        upd = fd2str(args[0])
    s = fd2str(t)
    c = dm.Form(s, upd)
    return fans(c)


def Let(u):
    return dm.Let(fd2str(u))


def Val(u):
    b = dm.Val(u)
    k = u.find('.Index')
    m = u.find('.Value')
    z = u.find('.SetText')
    if k > -1:
        b = int(b)
    elif m > -1:
        b = int(b)
    elif z > -1:
        b = b.replace('\n','')
        b = b.replace('\r','|')
    else:
        if b == 'True': b = True
        if b == 'False': b = False
    return b


def OpenDialog(*args):
    if len(args) == 0:
        multiselect = False
        title = ''
        initdir = ''
        fltr = ''
        fltr_ind = 0
    elif len(args) == 1:
        multiselect = args[0]
        title = ''
        initdir = ''
        fltr = ''
        fltr_ind = 0
    elif len(args) == 2:
        multiselect = args[0]
        title = args[1]
        initdir = ''
        fltr = ''
        fltr_ind = 0
    elif len(args) == 3:
        multiselect = args[0]
        title = args[1]
        initdir = args[2]
        fltr = ''
        fltr_ind = 0
    elif len(args) == 4:
        multiselect = args[0]
        title = args[1]
        initdir = args[2]
        fltr = args[3]
        fltr_ind = 0
    else:
        multiselect = args[0]
        title = args[1]
        initdir = args[2]
        fltr = args[3]
        fltr_ind = args[4]
    c = dm.OpenDialog(multiselect, title, initdir, fltr, fltr_ind)
    if multiselect:
        if c: return c.split('|')
        else: return []
    else:
        return c


def WActive(*args):
    if len(args) == 0:
        k = -1
    else:
        k = args[0]
    return dm.WActive(k)


def WFilter(i, j, c, *args):
    if len(args) == 0:
        g = True
    else:
        g = args[0]
    dm.WFilter(i, j, c, g)
    return 1


def WSel(i, *args):
    if len(args) == 0:
        x = -1
        y = 0
    elif len(args) == 1:
        x = args[0]
        y = 0
    else:
        x = args[0]
        y = args[1]
    c = dm.WSel(i, x, y)
    z = c.split('|')
    return int(z[0]), int(z[1])


def WClearSel(i):
    x, _ = WSel(i)
    WSel(i, x, 0)
    return None


def WSelText(i, *args):
    if len(args) == 0:
        c = '\3\3\3'
    else:
        c = args[0]
    return dm.WSelText(i, c)


def WNew(i, *args):
    if len(args) == 0:
        newtext = ''
        mode = True
    elif len(args) == 1:
        newtext = args[0]
        mode = True
    else:
        newtext = args[0]
        mode = args[1]
    dm.WNew(i, newtext, mode)
    return None


def WAdd(i, j, *args):
    if len(args) == 0:
        dm.WAdd(i,j,'')
    if len(args) == 1:
        dm.WAdd(i,j,args[0])
    return None


def WOpen(i, fn, *args):
    if len(args) == 0:
        p = False
    else:
        p = args[0]
    dm.WOpen(i, fn, p)
    return None

def WSave(i, *args):
    if len(args) == 0:
        fn = ''
    else:
        fn = args[0]
    dm.WSave(i, fn)
    return None  


def RexRepl(s, p, *args):
    if len(args) == 0:    
        g = True
    else:
        g = args[0]
    p = '\n'.join(p)
    return dm.PowerRepl(s, p, 1, g)


def DicRepl(s, p, *args):
    if len(args) == 0:    
        g = True
    else:
        g = args[0]
    p = '\n'.join(p)
    return dm.PowerRepl(s, p, 2, g)


def GaugeInit(n):
    dm.Gauge(-n)
    return None


def Gauge(i):
   dm.Gauge(i)
   return None



SaveDialog = dm.SaveDialog


ShowMessage = dm.ShowMessage


StatusMessage = dm.StatusMessage


ExecLua = dm.ExecLua


WText = dm.WText


WName = dm.WName


Cancel = dm.Cancel


BreakKeyName = dm.BreakKeyName


CurrentLang = dm.CurrentLang


